## chibicc 0+git20220719+ds

=== Makefile ===
CFLAGS=-std=c11 -g -fno-common -Wall -Wno-switch

SRCS=$(wildcard *.c)
OBJS=$(SRCS:.c=.o)

TEST_SRCS=$(wildcard test/*.c)
TESTS=$(TEST_SRCS:.c=.exe)

# Stage 1

chibicc: $(OBJS)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

$(OBJS): chibicc.h

test/%.exe: chibicc test/%.c
	./chibicc -Iinclude -Itest -c -o test/$*.o test/$*.c
	$(CC) -pthread -o $@ test/$*.o -xc test/common

test: $(TESTS)
	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
	test/driver.sh ./chibicc

test-all: test test-stage2

# Stage 2

stage2/chibicc: $(OBJS:%=stage2/%)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

stage2/%.o: chibicc %.c
	mkdir -p stage2/test
	./chibicc -c -o $(@D)/$*.o $*.c

stage2/test/%.exe: stage2/chibicc test/%.c
	mkdir -p stage2/test
	./stage2/chibicc -Iinclude -Itest -c -o stage2/test/$*.o test/$*.c
	$(CC) -pthread -o $@ stage2/test/$*.o -xc test/common

test-stage2: $(TESTS:test/%=stage2/test/%)
	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
	test/driver.sh ./stage2/chibicc

# Misc.

clean:
	rm -rf chibicc tmp* $(TESTS) test/*.s test/*.exe stage2
	find * -type f '(' -name '*~' -o -name '*.o' ')' -exec rm {} ';'

.PHONY: test clean test-stage2

=== debian/changelog ===
chibicc (0+git20220719+ds-4) unstable; urgency=medium

  * d/control: restrict to only amd64.

 -- Gürkan Myczko <tar@debian.org>  Mon, 03 Oct 2022 08:59:27 +0200

chibicc (0+git20220719+ds-3) unstable; urgency=medium

  * d/control: restrict the architectures. (Closes: #1021025)

 -- Gürkan Myczko <tar@debian.org>  Sun, 02 Oct 2022 19:52:31 +0200

chibicc (0+git20220719+ds-2) unstable; urgency=medium

  * Pass CFLAGS to dh_auto_build. Thanks for the patch Vagrant Cascadian.
    (Closes: #1020719)

 -- Gürkan Myczko <tar@debian.org>  Mon, 26 Sep 2022 09:47:38 +0200

chibicc (0+git20220719+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1015797)

 -- Gürkan Myczko <tar@debian.org>  Tue, 19 Jul 2022 09:12:55 +0200

=== debian/control ===
Source: chibicc
Section: devel
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.1
Homepage: https://github.com/rui314/chibicc
#Vcs-Browser: https://salsa.debian.org/debian/chibicc
#Vcs-Git: https://salsa.debian.org/debian/chibicc.git

Package: chibicc
Architecture: amd64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: small C compiler
 This is yet another small C compiler that implements most C11 features.
 Even though it still probably falls into the "toy compilers" category just
 like other small compilers do, chibicc can compile several real-world
 programs, including Git, SQLite, libpng and chibicc itself, without making
 modifications to the compiled programs. Generated executables of these
 programs pass their corresponding test suites. So, chibicc actually supports
 a wide variety of C11 features and is able to compile hundreds of thousands
 of lines of real-world C code correctly.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CFLAGS)"

## chibicc 0+git20240328+ds

=== Makefile ===
CC=gcc
CFLAGS =-std=c11 -g -fno-common -Wall -Wno-switch 
CFLAGS_DIAG=-dotfile
OBJECT=chibicc
OBJECTLIB=libchibicc
SRCS=$(wildcard *.c)
OBJS=$(SRCS:.c=.o)

TEST_SRCS=$(wildcard test/*.c)
TESTS=$(TEST_SRCS:.c=.exe)
ISSUES_SRCS=$(wildcard issues/*.c)
#PNG=$(TEST_SRCS:.c=.tmp)
#PNG2=$(ISSUES_SRCS:.c=.tmp)

# Stage 1

$(OBJECT): $(OBJS)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

$(OBJS): $(OBJECT).h

test/%.exe: $(OBJECT) test/%.c 
	./$(OBJECT) $(CFLAGS_DIAG) -Iinclude -Itest -c -o test/$*.o test/$*.c 
	$(CC) -pthread -o $@ test/$*.o -xc test/common
	dot -Tpng test/$*.dot -o diagram/$*.png || echo $*.dot failed
	

test: $(TESTS) 
	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
	test/driver.sh ./$(OBJECT)


# #for managing dot diagram
# test-png: $(TESTS)
	
test-all: test test-stage2 

# Stage 2

stage2/$(OBJECT): $(OBJS:%=stage2/%)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

stage2/%.o: $(OBJECT) %.c
	mkdir -p stage2/test
	./chibicc -c -o $(@D)/$*.o $*.c 

stage2/test/%.exe: stage2/$(OBJECT) test/%.c
	mkdir -p stage2/test
	./stage2/$(OBJECT) -Iinclude -Itest -c -o stage2/test/$*.o test/$*.c 
	$(CC) -pthread -o $@ stage2/test/$*.o -xc test/common

test-stage2: $(TESTS:test/%=stage2/test/%)
	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
	test/driver.sh ./stage2/$(OBJECT)

projects-all: projects openssl nmap curl

projects: zlib util-linux nginx


curl:
	cd ../curl && make clean && make && make test

zlib:
	cd ../zlib && make clean && make && make test

nmap:
	cd ../nmap && make clean && make

openssl:
	cd ../openssl && make clean && make 

util-linux:
	cd ../util-linux && make clean && make && make check-programs && cd tests && ./run.sh

nginx:
	cd ../nginx && make clean && CC=chibicc CFLAGS=-fPIC ./auto/configure && make 

# Misc.

libchibicc:  $(OBJECT) $(OBJECTLIB).so
CFLAGS +=-fPIC


libchibicc.so: $(OBJS)
	gcc $(CFLAGS) -o $@ $^ -shared

clean:
	rm -rf $(OBJECT) tmp* $(TESTS) issues/*.s issues/*.exe issues/*.dot test/*.s test/*.exe stage2 diagram/*.png test/*.dot $(OBJECTLIB)
	find * -type f '(' -name '*~' -o -name '*.o' ')' -exec rm {} ';'

install:
	test -d /usr/local/include/x86_64-linux-gnu/chibicc || \
		sudo mkdir -p /usr/local/include/x86_64-linux-gnu/chibicc
	sudo cp include/* /usr/local/include/x86_64-linux-gnu/chibicc/
	sudo cp chibicc /usr/local/bin/chibicc

uninstall:
	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm /usr/local/bin/chibicc

.PHONY: test clean test-stage2 libchibicc projects projects-all test-all install uninstall

=== debian/changelog ===
chibicc (0+git20240328+ds-2) unstable; urgency=medium

  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Jul 2024 19:45:40 +0000

chibicc (0+git20240328+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1066724)
  * d/rules: skip tests.

 -- Gürkan Myczko <tar@debian.org>  Thu, 28 Mar 2024 09:55:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: chibicc
 Section: devel
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Alex Myczko <tar@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Homepage: https://github.com/rui314/chibicc
 #Vcs-Browser: https://salsa.debian.org/debian/chibicc
 #Vcs-Git: https://salsa.debian.org/debian/chibicc.git

=== debian/rules ===
--- 
+++ 
@@ -15,3 +15,9 @@
 
 override_dh_auto_build:
 	dh_auto_build -- CFLAGS="$(CFLAGS)"
+
+override_dh_auto_install:
+	@echo we dont use sudo.
+
+override_dh_auto_test:
+	@echo skip tests.

## chibicc 1.0.23.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22.1)
install(PROGRAMS ${Boost_LIBRARIES} DESTINATION ~/install/lib)

set(CMAKE_CXX_STANDARD 20)

project(chibicc)

FIND_PACKAGE(Boost 1.48 COMPONENTS REQUIRED)
INCLUDE_DIRECTORIES( ${Boost_INCLUDE_DIR} )

file(GLOB SOURCE
        "*.h"
        "*.c"
        "include/*.h")

add_executable(chibicc ./main.c  ${SOURCE} ${Boost_LIBRARIES})

=== Makefile ===
CC=gcc
CFLAGS =-std=c11 -g -fno-common -Wall -Wno-switch 
CFLAGS_DIAG=-dotfile -std=c11 
OBJECT=chibicc
OBJECTLIB=libchibicc
SRCS=$(wildcard *.c)
OBJS=$(SRCS:.c=.o)

TEST_SRCS=$(wildcard test/*.c)
TESTS=$(TEST_SRCS:.c=.exe)
ISSUES_SRCS=$(wildcard issues/*.c)
#PNG=$(TEST_SRCS:.c=.tmp)
#PNG2=$(ISSUES_SRCS:.c=.tmp)

# Stage 1

$(OBJECT): $(OBJS)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

$(OBJS): $(OBJECT).h

test/%.exe: $(OBJECT) test/%.c 
	./$(OBJECT) $(CFLAGS_DIAG) -Iinclude -Itest -c -o test/$*.o test/$*.c 
	$(CC) -pthread -o $@ test/$*.o -xc test/common -lm
#	dot -Tpng test/$*.dot -o diagram/$*.png || echo $*.dot failed
	

test: $(TESTS) 
	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
	test/driver.sh ./$(OBJECT)


# #for managing dot diagram
# test-png: $(TESTS)
	
test-all: test test-stage2 

# Stage 2

stage2/$(OBJECT): $(OBJS:%=stage2/%)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

stage2/%.o: $(OBJECT) %.c
	mkdir -p stage2/test
	./chibicc -c -o $(@D)/$*.o $*.c 

stage2/test/%.exe: stage2/$(OBJECT) test/%.c
	mkdir -p stage2/test
	./stage2/$(OBJECT) -Iinclude -Itest -c -o stage2/test/$*.o test/$*.c 
	$(CC) -pthread -o $@ stage2/test/$*.o -xc test/common

test-stage2: $(TESTS:test/%=stage2/test/%)
	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
	test/driver.sh ./stage2/$(OBJECT)

projects-all: projects projects-oth git

projects-oth: openssl vim nmap curl 

projects: zlib util-linux nginx


curl:
	cd ../curl && make clean && CC=chibicc  CFLAGS="-std=c11" ./configure --with-openssl && make && make test

zlib:
	cd ../zlib && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make test

nmap:
	cd ../nmap && make clean && CC=chibicc LDFLAGS="-fPIC -std=c11 -ldbus-1" LIBS="-ldbus-1 -latomic" ./configure --with-dbus && make && make check

openssl:
	cd ../openssl && make clean && CC=chibicc CFLAGS="-std=c11" ./configure && make 

util-linux:
	cd ../util-linux && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make check-programs && cd tests && ./run.sh

nginx:
	cd ../nginx && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./auto/configure --with-http_ssl_module && make

vim:
	cd ../vim && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make test

lxc:
	cd ../lxc && rm -rf build && CC=gcc \
	meson setup build && cd build && sudo cp /usr/bin/gcc /usr/bin/gcc_backup \
	sudo cp /usr/local/bin/chibicc /usr/bin/gcc && meson compile && sudo cp /usr/bin/gcc_backup /usr/bin/gcc

vlc:
	cd ../vlc && make clean && CC=chibicc CFLAGS="-fPIC -std=c11"  ./configure  \
	--disable-lua --disable-xcb --disable-qt --disable-alsa --disable-sse --host x86_64-linux-gnu && \
    make all

cpython:
	cd ../cpython && make clean && CC=chibicc ./configure \
	 --build=x86_64-pc-linux-gnu ac_cv_have_lchflags=no ac_cv_have_chflags=no && make && make test

# vlc2:
# 	cd ../vlc && rm -rf build && mymeson setup build && cd build && mymeson compile


git: 
	cd ../git && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make test

memcached:
	cd ../memcached && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make test

openssh-portable:
	cd ../openssh-portable && make clean && CC=chibicc CFLAGS="-std=c11" ./configure && make && make tests


# Misc.

libchibicc:  $(OBJECT) $(OBJECTLIB).so
CFLAGS +=-fPIC


libchibicc.so: $(OBJS)
	$(CC) $(CFLAGS) -o $@ $^ -shared

clean:
	rm -rf $(OBJECT) tmp* $(TESTS) issues/*.s issues/*.exe issues/*.dot test/*.s test/*.exe stage2 diagram/*.png test/*.dot $(OBJECTLIB)
	find * -type f '(' -name '*~' -o -name '*.o' ')' -exec rm {} ';'

install:
	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm -rf /usr/local/bin/chibicc
	test -d /usr/local/include/x86_64-linux-gnu/chibicc || \
		sudo mkdir -p /usr/local/include/x86_64-linux-gnu/chibicc
	sudo cp -r include/* /usr/local/include/x86_64-linux-gnu/chibicc/
	sudo cp ./chibicc /usr/local/bin/chibicc

uninstall:
	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm /usr/local/bin/chibicc

.PHONY: test clean test-stage2 libchibicc projects projects-all  projects-oth test-all install uninstall

=== debian/changelog ===
chibicc (1.0.23.1-1) unstable; urgency=medium

  * New upstream version.
  * d/upstream/metadata: updated.
  * d/copyright: bump years.
  * d/control:
    - update homepage field.
    - uncommented Vcf fields.
  * Bump standard version to 4.7.2.

 -- Alex Myczko <tar@debian.org>  Tue, 23 Sep 2025 12:11:36 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.7.0
-Homepage: https://github.com/rui314/chibicc
-#Vcs-Browser: https://salsa.debian.org/debian/chibicc
-#Vcs-Git: https://salsa.debian.org/debian/chibicc.git
+Standards-Version: 4.7.2
+Homepage: https://github.com/stormalf/chibicc
+Vcs-Browser: https://salsa.debian.org/debian/chibicc
+Vcs-Git: https://salsa.debian.org/debian/chibicc.git
 
 Package: chibicc
 Architecture: amd64

## chibicc 1.0.23.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
+# The installation prefix
+PREFIX=/usr/local
+
+GCC_VERSION!=gcc -dumpversion
 CC=gcc
-CFLAGS =-std=c11 -g -fno-common -Wall -Wno-switch 
-CFLAGS_DIAG=-dotfile -std=c11 
+CFLAGS =-std=c11 -g -fno-common -Wall -Wno-switch -DPREFIX=\"$(PREFIX)\" -DGCC_VERSION=\"$(GCC_VERSION)\"
+CFLAGS_DIAG= -std=c11 
 OBJECT=chibicc
 OBJECTLIB=libchibicc
 SRCS=$(wildcard *.c)
@@ -53,9 +57,9 @@
 	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
 	test/driver.sh ./stage2/$(OBJECT)
 
-projects-all: projects projects-oth git
+projects-all: projects projects-oth lxc vlc git memcached cpython openssl
 
-projects-oth: openssl vim nmap curl 
+projects-oth: vim nmap curl 
 
 projects: zlib util-linux nginx
 
@@ -67,10 +71,10 @@
 	cd ../zlib && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make test
 
 nmap:
-	cd ../nmap && make clean && CC=chibicc LDFLAGS="-fPIC -std=c11 -ldbus-1" LIBS="-ldbus-1 -latomic" ./configure --with-dbus && make && make check
+	cd ../nmap && make clean && CC=chibicc  CFLAGS="-fPIC -std=c11" LIBS="-ldbus-1 -latomic -libverbs -lrdmacm" ./configure --with-dbus && make && make check
 
 openssl:
-	cd ../openssl && make clean && CC=chibicc CFLAGS="-std=c11" ./configure && make 
+	cd ../openssl && make clean && CC=chibicc CFLAGS="-std=c11" ./Configure && make 
 
 util-linux:
 	cd ../util-linux && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make check-programs && cd tests && ./run.sh
@@ -83,7 +87,7 @@
 
 lxc:
 	cd ../lxc && rm -rf build && CC=gcc \
-	meson setup build && cd build && sudo cp /usr/bin/gcc /usr/bin/gcc_backup \
+	meson setup build && cd build && sudo cp /usr/bin/gcc /usr/bin/gcc_backup  && \
 	sudo cp /usr/local/bin/chibicc /usr/bin/gcc && meson compile && sudo cp /usr/bin/gcc_backup /usr/bin/gcc
 
 vlc:
@@ -92,7 +96,7 @@
     make all
 
 cpython:
-	cd ../cpython && make clean && CC=chibicc ./configure \
+	cd ../cpython &&  CC=chibicc ./configure \
 	 --build=x86_64-pc-linux-gnu ac_cv_have_lchflags=no ac_cv_have_chflags=no && make && make test
 
 # vlc2:
@@ -122,14 +126,12 @@
 	rm -rf $(OBJECT) tmp* $(TESTS) issues/*.s issues/*.exe issues/*.dot test/*.s test/*.exe stage2 diagram/*.png test/*.dot $(OBJECTLIB)
 	find * -type f '(' -name '*~' -o -name '*.o' ')' -exec rm {} ';'
 
-install:
-	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm -rf /usr/local/bin/chibicc
-	test -d /usr/local/include/x86_64-linux-gnu/chibicc || \
-		sudo mkdir -p /usr/local/include/x86_64-linux-gnu/chibicc
-	sudo cp -r include/* /usr/local/include/x86_64-linux-gnu/chibicc/
-	sudo cp ./chibicc /usr/local/bin/chibicc
+install: $(OBJECT)
+	install -v -D -m 755 -t $(PREFIX)/bin/ $(OBJECT)
+	install -v -D -m 644 -t $(PREFIX)/include/x86_64-linux-gnu/chibicc/ include/*
 
 uninstall:
-	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm /usr/local/bin/chibicc
+	rm -f $(PREFIX)/bin/chibicc
+	rm -f $(PREFIX)/include/x86_64-linux-gnu/chibicc/*
 
 .PHONY: test clean test-stage2 libchibicc projects projects-all  projects-oth test-all install uninstall

=== debian/changelog ===
chibicc (1.0.23.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Alex Myczko <tar@debian.org>  Wed, 17 Dec 2025 11:17:09 +0000

chibicc (1.0.23.2-1) experimental; urgency=medium

  * New upstream version.
  * d/control: drop Rules-Requires-Root.

 -- Alex Myczko <tar@debian.org>  Fri, 12 Dec 2025 13:36:16 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: devel
 Priority: optional
 Maintainer: Alex Myczko <tar@debian.org>
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
 Standards-Version: 4.7.2
